package it.amattioli.dominate;

import it.amattioli.dominate.util.PropertyChangeEmitter;

/**
 * An interface for a filter that can be passed to
 * {@link Repository#list(Filter)}.
 *
 * @author a.mattioli
 *
 */
@Deprecated
public interface Filter extends PropertyChangeEmitter {

	/**
     * Retrieves the index of the first object that will be retrieved when
     * using this filter.
     * 
     * @return the index of the first object that will be retrieved when
     *         using this filter
     */
	public int getFirst();
	
	/**
     * Set the index of the first object that will be retrieved when
     * using this filter.
     *
     * @param first the index of the first object that will be retrieved when
     *              using this filter
     */ 
	public void setFirst(int first);
	
	/**
     * Retrieves the index of the last object that will be retrieved when
     * using this filter.
     * This method will retrieve the same number that has been set using
     * {@link #setLast(int)}.
     *
     * @return the index of the last object that will be retrieved when 
     *         using this filter
     */
	public int getLast();
	
	/**
     * Set the index of the last object that will be retrieved when
     * using this filter.
     * If the repository contains less objects than the indicated index,
     * all the objects will be retrieved.
     *
     * @param last the index of the last object that will be retrieved when
     *        using this filter
     */
	public void setLast(int last);
	
	public void doFilter();
	
}
