package it.amattioli.dominate.hibernate;

import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;

import org.apache.commons.collections.Predicate;
import org.hibernate.Criteria;
import org.hibernate.Query;

public abstract class AbstractHibernateFilter implements HibernateFilter {
	private int first;
	private int last;
    private PropertyChangeSupport pChange = new PropertyChangeSupport(this);

    public void addPropertyChangeListener(final PropertyChangeListener listener) {
        pChange.addPropertyChangeListener(listener);
    }

    public void removePropertyChangeListener(final PropertyChangeListener listener) {
        pChange.removePropertyChangeListener(listener);
    }

    public void firePropertyChange(final String propertyName, final Object oldValue, final Object newValue) {
        pChange.firePropertyChange(propertyName, oldValue, newValue);
    }

    @Override
    public int getFirst() {
		return first;
	}

    @Override
	public void setFirst(int first) {
		this.first = first;
	}

    @Override
	public int getLast() {
		return last;
	}

    @Override
	public void setLast(int last) {
		this.last = last;
	}

	public String getHqlQuery() {
        return null;
    }

    public String getHqlFilter() {
        return null;
    }

    public void setHqlParameters(final Query query) {
        // Non fa nulla
    }

    public void customize(final Criteria crit) {
        // Non fa nulla
    }

    public Predicate getCollectionPredicate() {
        return null;
    }
    
    public void doFilter() {
        firePropertyChange("", null, null);
    }

}
