package it.amattioli.dominate.hibernate.filters;


import org.hibernate.Criteria;
import org.hibernate.Query;
import org.hibernate.criterion.Restrictions;

public class LongFilter implements HibernateAttributeFilter<Long> {
	private String alias;
    private String attributeName;
    private Long value;

    public LongFilter(String attributeName) {
        this.attributeName = attributeName;
    }
    
    public LongFilter(String alias, String attributeName) {
        this.attributeName = attributeName;
        this.alias = alias;
    }

    protected boolean wasSet() {
        return get() != null;
    }

    public void addCriteria(Criteria crit) {
        if (wasSet()) {
            crit.add(Restrictions.eq(attributeName, get()));
        }
    }

    public void addHqlCondition(StringBuffer buffer) {
        if (wasSet()) {
            if (buffer.length() == 0) {
                buffer.append("where ");
            } else {
                buffer.append("and ");
            }
            if (alias != null) {
            	buffer.append(alias).append('.');
            }
            buffer.append(attributeName)
                  .append(" = :")
                  .append(attributeName.replace('.', '_'))
                  .append(" ");
        }
    }

    public void setHqlParam(Query query) {
        if (wasSet()) {
            query.setParameter(attributeName.replace('.', '_'), get());
        }
    }

    public Long get() {
        return value;
    }

    public void set(Long value) {
        this.value = value;
    }

}
