package it.amattioli.dominate.specifications.beans;

import java.beans.PropertyDescriptor;

import it.amattioli.dominate.Entity;
import it.amattioli.dominate.Specification;
import it.amattioli.dominate.specifications.EntitySpecification;

public class EntityPropertySpecificationFactory implements PropertySpecificationFactory {

	@Override
	public boolean canBuildSpecificationFor(PropertyDescriptor descriptor) {
		return Entity.class.isAssignableFrom(descriptor.getPropertyType());
	}

	@Override
	public <T extends Entity<?>> Specification<T> newSpecification(PropertyDescriptor descriptor) {
		return EntitySpecification.newInstance(descriptor.getName(), (Class<Entity>)descriptor.getPropertyType());
	}

}
