package it.amattioli.dominate.specifications.beans;

import java.beans.PropertyDescriptor;

import it.amattioli.dominate.Entity;
import it.amattioli.dominate.Specification;
import it.amattioli.dominate.specifications.EnumSpecification;

public class EnumPropertySpecificationFactory implements PropertySpecificationFactory {

	@Override
	public boolean canBuildSpecificationFor(PropertyDescriptor descriptor) {
		return descriptor.getPropertyType().isEnum();
	}

	@Override
	public <T extends Entity<?>> Specification<T> newSpecification(PropertyDescriptor descriptor) {
		return EnumSpecification.newInstance(descriptor.getName(), (Class<Enum>)descriptor.getPropertyType());
	}

}
