package it.amattioli.dominate.specifications.beans;

import java.beans.PropertyDescriptor;

import it.amattioli.dominate.Entity;
import it.amattioli.dominate.Specification;
import it.amattioli.dominate.specifications.StringSpecification;

public class StringPropertySpecificationFactory implements PropertySpecificationFactory{

	@Override
	public boolean canBuildSpecificationFor(PropertyDescriptor descriptor) {
		return String.class.equals(descriptor.getPropertyType());
	}

	@Override
	public <T extends Entity<?>> Specification<T> newSpecification(PropertyDescriptor descriptor) {
		return StringSpecification.newInstance(descriptor.getName());
	}

}
