package it.amattioli.dominate.specifications.hibernate;

import org.hibernate.criterion.Restrictions;

import it.amattioli.dominate.Entity;
import it.amattioli.dominate.specifications.Assembler;
import it.amattioli.dominate.specifications.StringSpecification;

public class CriteriaStringSpecification<T extends Entity<?>> extends StringSpecification<T> {

	public CriteriaStringSpecification() {
		
	}
	
	public CriteriaStringSpecification(String propertyName) {
		super(propertyName);
	}

	@Override
	public void itselfAssembleQuery(Assembler assembler) {
		addCriteria((CriteriaAssembler) assembler);
	}

	@Override
	public boolean itselfSupportsAssembler(Assembler assembler) {
		return assembler instanceof CriteriaAssembler;
	}
	
	private void addCriteria(CriteriaAssembler assembler) {
        if (wasSet()) {
        	assembler.addCriterion(Restrictions.ilike(getPropertyName(), getValue(), getComparisonType().getMatchMode()));
        }
    }

}
